<template>
  <div class="mainpanel" ref="toppage">
    <div
      class="mainPoster row"
      :style="{ 'background-image': 'url(' + bgFile + ')' }"
    >
      <div class="q-pa-md q-pt-md" style="vertical-align: middle">
        <img style="height: 300px" :src="coverPic" :alt="title" />
      </div>
      <div class="col q-pa-md">
        <div class="font-32">{{ title }}</div>
        <div>{{ catName }}</div>
        <div class="font-14 q-pt-md">{{ synopsis }}</div>
      </div>
    </div>
    <show-ads />
    <div
      v-for="(item, index) in pageData"
      :key="index"
      align="center"
      style="font-size: 0px"
    >
      <img
        :src="convertPic(item)"
        style="width: 100%; max-width: 700px"
        :alt="title"
      />
    </div>

    <div class="row justify-between q-py-md">
      <div class="q-px-md">
        <q-btn
          icon="fas fa-caret-left"
          rounded
          color="primary"
          label="ตอนที่แล้ว"
          alt="ตอนที่แล้ว"
          @click="perviousChapterBtn()"
          :disable="!nextPage"
        />
      </div>
      <div class="q-px-md">
        <q-btn
          icon-right="fas fa-caret-right"
          rounded
          color="primary"
          label="ตอนต่อไป"
          alt="ตอนต่อไป"
          :disable="!perviousPage"
          @click="nextChapterBtn()"
        />
      </div>
    </div>
    <show-ads />
    <div class="font-24 q-px-md q-mt-md topic">แนะนำ</div>
    <div class="row">
      <div
        v-for="(item2, index2) in data"
        :key="index2"
        style="width: 25%"
        align="center"
      >
        <div class="cover-footer">
          <img
            :src="openPic(item2.bookid)"
            :alt="item2.title"
            class="cover-pic"
            @click="showBook(item2.bookid)"
          />
          <div
            class="cover-title ellipsis-3-lines"
            @click="showBook(item2.bookid)"
          >
            {{ item2.title }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import showAds from "../../components/ads.vue";
import axios from "axios";
export default {
  props: ["bookData", "catData", "pageData", "perviousPage", "nextPage"],
  components: { showAds },
  data() {
    return {
      bgFile: "",
      coverPic: "",
      title: "",
      synopsis: "",
      catName: "",
      data: [],
    };
  },
  methods: {
    openPic(id) {
      return this.serverpath + "cover/" + id + ".jpg";
    },
    nextChapterBtn() {
      this.$emit("perviousChapter");
    },
    perviousChapterBtn() {
      this.$emit("nextChapter");
    },
    convertPic(item) {
      return this.serverpath + "/" + item;
    },
    loadTitleBox() {
      this.bgFile =
        this.serverpath +
        "bg/" +
        this.bookData[0].bookid +
        ".jpg?" +
        Math.random() * 2000;
      this.coverPic =
        this.serverpath +
        "cover/" +
        this.bookData[0].bookid +
        ".jpg?" +
        Math.random() * 2000;
      this.title = this.bookData[0].title;
      this.synopsis = this.bookData[0].synopsis;
      this.catName = this.findCatName(this.bookData[0].catid);
    },
    findCatName(catid) {
      let catFinal = "";
      let cattemp = catid.split(",");

      cattemp.forEach((item) => {
        item = item.replace("[", "").replace("]", "");
        let cat = this.catData.filter((x) => x.catid == item);
        catFinal += cat[0].name + " | ";
      });
      catFinal = catFinal.slice(0, -3);

      return catFinal;
    },
    async loadCartoonFooter() {
      let url = this.serverpath + "cartoononfooter.php";
      let res = await axios.get(url);
      this.data = res.data;
    },
    showBook(id) {
      this.$router.push("/reload/" + id);
    },
  },
  mounted() {
    if (this.bookData.length > 0) {
      this.loadTitleBox();
      this.loadCartoonFooter();
    }
  },
  watch: {
    pageData: function (newPage, oldPage) {
      this.$refs.toppage.scrollTop = 0;
    },
    bookData: function (newData, oldData) {
      if (newData.length > 0) {
        this.loadTitleBox();
        this.loadCartoonFooter();
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.mainPoster {
  position: relative;
  margin: auto;
  width: 100%;
  height: 330px;
  background-color: #dfdede;
  background-size: cover;
}

.mainpanel {
  height: calc(100vh - 50px);
  overflow-y: auto;
}

.cover-pic {
  width: 100%;
  max-width: 200px;
  height: 300px;
  padding-top: 30px;
  cursor: pointer;
}
.cover-title {
  width: 200px;
  font-size: 14px;
  max-height: 65px;
  margin-bottom: 20px;
  text-align: center;
  cursor: pointer;
}
.cover-footer:hover {
  .cover-title {
    text-decoration: underline;
  }
}
</style>
